---
title: databases
slug: Web/API/IDBFactory/databases
tags:
  - API
  - Database
  - IDBFactory
  - Method
  - Reference
  - Storage
  - databases
---
<p>{{ APIRef("IndexedDB") }}</p>

<p>The <strong><code>databases</code></strong> method of the {{domxref("IDBFactory")}} interface returns a list represening all the available databases, including their names and versions.</p>

<p>{{AvailableInWorkers}}</p>

<div class="notecard note">
<p><strong>Note</strong>: This method is introduced in a draft of a specifications and browser compatibility is limited.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre>const promise = indexedDB.databases()</pre>

<h3 id="Parameters">Parameters</h3>

<p>The method does not take in any parameters.</p>

<h3 id="Return_value">Return value</h3>

<p>A promise that resolves either to an error or a list of dictionaries, each with two elements, <code>name</code> and <code>version</code>.</p>

<h4 id="name"><code>name</code></h4>

<dl>
 <dd>The database name.</dd>
</dl>

<h4 id="version"><code>version</code></h4>

<dl>
 <dd>The database version.</dd>
</dl>

<p><span style='background-color: #333333; color: #ffffff; font-family: x-locale-heading-primary,zillaslab,Palatino,"Palatino Linotype",x-locale-heading-secondary,serif; font-size: 1.44444rem; letter-spacing: -0.00278rem;'>Exceptions</span></p>

<p>This method may raise a {{domxref("DOMException")}} of the following types:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Attribute</th>
   <th scope="col">Description</th>
  </tr>
  <tr>
   <td>{{exception("SecurityError")}}</td>
   <td>The method is called from an opaque origin.</td>
  </tr>
  <tr>
   <td>Other error</td>
   <td>Specification does not describe all possible errors.</td>
  </tr>
 </thead>
</table>

<h2 id="Example">Example</h2>

<pre>const promise = indexedDB.databases()
promise.then(databases =&gt; {
  console.log(databases)
})
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB 2", "#dom-idbfactory-databases", "databases()")}}</td>
   <td>{{Spec2("IndexedDB 2")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">
<p>The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("api.IDBFactory.databases")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
